############################################################
# This script accompanies the book "Windows NT Configuration
# and Maintenance" by Matthew M Lavy and Ashley J Meggitt
# (published by O'Reilly, 1999)
# The script is copyright, 1999 Matthew Lavy & Ashley Meggitt
# 
# WARNING: This script is provided in electronic format as a
# convenience for readers of the book it accompanies. It may
# well require site-specific customisation before it works at
# all, and may cause damage to a workstation if run without this
# customisation (please refer to the book for details).
# DO NOT RUN THIS SCRIPT UNLESS YOU HAVE CHECKED THOROUGHLY THAT
# IT IS SAFE TO DO SO. The authors accept no liability for any
# damage caused by running the script.


#LogProbems.pl

use Win32::EventLog;
use Net::SMTP;
@eventlogs = ("system","security","application");

foreach $logtype(@eventlogs)
{
$evtlog = Win32::EventLog->new($logtype, $ENV{COMPUTERNAME});
while ($evtlog->Read(EVENTLOG_FORWARDS_READ | EVENTLOG_SEQUENTIAL_READ,0,\%eventinfo))
{
if ($eventinfo{'EventType'} & 3) #it's an error/warning
{
if($eventinfo{'EventType'} & 1) #an error
{
$errors = "${errors}$eventinfo{'Source'}($logtype log)\n";
}
else #a warning
{
$warnings = "${warnings}$eventinfo{'Source'}($logtype log)\n";
}
}
}
}
if($errors || $warnings)
{
if($errors){$errors = "Errors were logged by the following sources:\n\n$errors";}
if($warnings){$warnings = "Warnings were logged by the following sources: \n\n$warnings";}
$message = "Event log report for $ENV{COMPUTERNAME}\n";
$message = "${message}------------------------------\n";
$message = "${message}\n${errors}\n${warnings}\n";
$message = "${message}Please check the event logs for details\n";

$smtp = Net::SMTP->new('smtp.scripters.com');
$smtp->mail('eventlogger@scripters.com');
$smtp->to('ntadmin@scripters.com');
$smtp->data($message);
$smtp->dataend();
$smtp->quit;
}